# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2022/6/17
"""
去水印功能
"""
import sys

from typing import List

from alibabacloud_mts20140618.client import Client as Mts20140618Client
from alibabacloud_tea_openapi import models as open_api_models
from alibabacloud_mts20140618 import models as mts_20140618_models
from alibabacloud_tea_util import models as util_models
# from alibabacloud_tea_util.client import Client as UtilClient

from main.common import Common


class DelLogo:
    def __init__(self):
        pass

    @staticmethod
    def create_client(
            access_key_id: str,
            access_key_secret: str,
    ) -> Mts20140618Client:
        """
        使用AK&SK初始化账号Client
        @param access_key_id:
        @param access_key_secret:
        @return: Client
        @throws Exception
        """
        config = open_api_models.Config(
            # 您的 AccessKey ID,
            access_key_id=access_key_id,
            # 您的 AccessKey Secret,
            access_key_secret=access_key_secret
        )
        # 访问的域名
        config.endpoint = f'mts.cn-hangzhou.aliyuncs.com'
        return Mts20140618Client(config)

    @staticmethod
    def main(log_type, args: List[str], ) -> None:
        client = DelLogo.create_client('accessKeyId', 'accessKeySecret')
        submit_iproduction_job_request = mts_20140618_models.SubmitIProductionJobRequest()
        runtime = util_models.RuntimeOptions()
        try:
            # 复制代码运行请自行打印 API 的返回值
            client.submit_iproduction_job_with_options(submit_iproduction_job_request, runtime)
        except Exception as error:
            # 如有需要，请打印 error
            Common.logger(log_type).error(error)

    @staticmethod
    async def main_async(log_type, args: List[str], ) -> None:
        client = DelLogo.create_client('accessKeyId', 'accessKeySecret')
        submit_iproduction_job_request = mts_20140618_models.SubmitIProductionJobRequest()
        runtime = util_models.RuntimeOptions()
        try:
            # 复制代码运行请自行打印 API 的返回值
            await client.submit_iproduction_job_with_options_async(submit_iproduction_job_request, runtime)
        except Exception as error:
            # 如有需要，请打印 error
            Common.logger(log_type).error(error)


if __name__ == '__main__':
    DelLogo.main("hour", sys.argv[1:])
